diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
index 8b8d52e4e..ecf7d7cfb 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuAbstract.java
@@ -18,6 +18,7 @@ import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
@@ -640,13 +641,13 @@ public abstract class MenuAbstract
      * Slots to move items from when using MOVE_ALL or MOVE_SIMILAR.
      * If the return value is null, MOVE_ALL and MOVE_SIMILAR won't do anything!
      */
-	public abstract IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player);
+	public abstract IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player);
 
 	/**
 	 * Slots to move items to when using any MOVE action.
 	 * If the return value is null, all MOVE actions won't do anything!
 	 */
-	public abstract IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player);
+	public abstract IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player);
 
 	/**
 	 * Pick up all items similar to the one the player is holding.
@@ -760,7 +761,7 @@ public abstract class MenuAbstract
 		}
 	}
 
-	public void onCraftGuiClosed(Player player) {
+	public void onCraftGuiClosed(@NotNull Player player) {
 		ContainerInventory inventory = player.inventory;
 		if(inventory.getHeldItemStack() != null) {
 			ItemStack stack = inventory.getHeldItemStack();
@@ -838,7 +839,7 @@ public abstract class MenuAbstract
 	{
 	}
 
-	public abstract boolean stillValid(Player entityplayer);
+	public abstract boolean stillValid(@NotNull Player player);
 
 	/**
 	 * Merge the given ItemStack into the given slots.
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
index ca13ca28a..ebfbbca85 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuActivator.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuActivator extends MenuAbstract {
 	public static final int ID_SELECTOR = 0;
@@ -80,12 +81,12 @@ public class MenuActivator extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return activator.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return activator.stillValid(player);
 	}
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(activatorSlotsStart, 9, false);
 		}
@@ -107,7 +108,7 @@ public class MenuActivator extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= activatorSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(inventorySlotsStart, 36, false);
 		}else {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
index 207c66d2b..2eab6553e 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuContainer.java
@@ -5,6 +5,7 @@ import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuContainer extends MenuAbstract {
 	
@@ -36,12 +37,12 @@ public class MenuContainer extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return container.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return container.stillValid(player);
 	}
 	
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
 		if(slot.index >= 0 && slot.index < chestSize) {
@@ -69,7 +70,7 @@ public class MenuContainer extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		int chestSize = numberOfRows * 9;
 		
 		if(slot.index < chestSize) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
index 143ef1808..6547d228e 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuCrafting.java
@@ -14,143 +14,134 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotResult;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class MenuCrafting extends MenuAbstract
-{
-	public final @NotNull ContainerCrafting craftSlots;
-	public final @NotNull Container resultSlots;
-	private final @NotNull World world;
-	private final @NotNull TilePos tilePos;
+public class MenuCrafting extends MenuAbstract {
+    public final @NotNull ContainerCrafting craftSlots;
+    public final @NotNull Container resultSlots;
+    private final @NotNull World world;
+    private final @NotNull TilePos tilePos;
 
-    public MenuCrafting(@NotNull ContainerInventory inventory, @NotNull World world, @NotNull TilePos tilePos)
-    {
-        craftSlots = new ContainerCrafting(this, 3, 3);
-        resultSlots = new ContainerResult();
+    public MenuCrafting(@NotNull ContainerInventory inventory, @NotNull World world, @NotNull TilePosc tilePos) {
+        this.craftSlots = new ContainerCrafting(this, 3, 3);
+        this.resultSlots = new ContainerResult();
         this.world = world;
-        this.tilePos = tilePos;
-        addSlot(new SlotResult(inventory.player, craftSlots, resultSlots, 0, 124, 35));
-        for(int l = 0; l < 3; l++)
-        {
-            for(int k1 = 0; k1 < 3; k1++)
-            {
-                addSlot(new Slot(craftSlots, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
+        this.tilePos = new TilePos(tilePos);
+        addSlot(new SlotResult(inventory.player, this.craftSlots, this.resultSlots, 0, 124, 35));
+        for (int l = 0; l < 3; l++) {
+            for (int k1 = 0; k1 < 3; k1++) {
+                addSlot(new Slot(this.craftSlots, k1 + l * 3, 30 + k1 * 18, 17 + l * 18));
             }
 
         }
 
-        for(int i1 = 0; i1 < 3; i1++)
-        {
-            for(int l1 = 0; l1 < 9; l1++)
-            {
+        for (int i1 = 0; i1 < 3; i1++) {
+            for (int l1 = 0; l1 < 9; l1++) {
                 addSlot(new Slot(inventory, l1 + i1 * 9 + 9, 8 + l1 * 18, 84 + i1 * 18));
             }
 
         }
 
-        for(int j1 = 0; j1 < 9; j1++)
-        {
+        for (int j1 = 0; j1 < 9; j1++) {
             addSlot(new Slot(inventory, j1, 8 + j1 * 18, 142));
         }
 
-        slotsChanged(craftSlots);
+        slotsChanged(this.craftSlots);
     }
 
     @Override
-	public void slotsChanged(Container iinventory)
-    {
-		resultSlots.setItem(0, Registries.RECIPES.findMatchingRecipe(craftSlots));
+    public void slotsChanged(Container container) {
+        this.resultSlots.setItem(0, Registries.RECIPES.findMatchingRecipe(this.craftSlots));
     }
 
-	@Override
-	public void onCraftGuiClosed(Player player) {
-		super.onCraftGuiClosed(player);
-		boolean insert = false;
-		for (int i = 0; i < 9; i++) {
-			ItemStack itemstack = craftSlots.getItem(i);
-			if(itemstack != null) {
-				storeOrDropItem(player, itemstack);
-				insert = true;
-			}
-			craftSlots.setItem(i, null);
-		}
-		resultSlots.setItem(0, null);
-		if(insert) {
-			player.world.playSoundAtEntity(null, player, "random.insert", 0.1F, 1.0f);
-		}
-	}
+    @Override
+    public void onCraftGuiClosed(@NotNull Player player) {
+        super.onCraftGuiClosed(player);
+        boolean insert = false;
+        for (int i = 0; i < 9; i++) {
+            ItemStack itemstack = this.craftSlots.getItem(i);
+            if (itemstack != null) {
+                storeOrDropItem(player, itemstack);
+                insert = true;
+            }
+            this.craftSlots.setItem(i, null);
+        }
+        this.resultSlots.setItem(0, null);
+        if (insert) {
+            player.world.playSoundAtEntity(null, player, "random.insert", 0.1F, 1.0f);
+        }
+    }
 
     @Override
-	public boolean stillValid(Player entityplayer)
-    {
-        if(world.getBlockId(tilePos) != Blocks.WORKBENCH.id())
-        {
+    public boolean stillValid(@NotNull Player player) {
+        if (this.world.getBlockId(this.tilePos) != Blocks.WORKBENCH.id()) {
             return false;
         }
-        return entityplayer.distanceToSqr((double) tilePos.x + 0.5D, (double) tilePos.y + 0.5D, (double) tilePos.z + 0.5D) <= 64D;
+        return player.distanceToSqr((double) this.tilePos.x + 0.5D, (double) this.tilePos.y + 0.5D, (double) this.tilePos.z + 0.5D) <= 64D;
     }
-    
+
     /*
      *  0 Craft Result
      *  1 - 9 Crafting (9x)
      *  10 - 36 Main ContainerInventory (27x)
      *  37 - 45 Hotbar (9x)
      */
-    
+
     @Override
-    public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
-    	if(slot.index == 0) {
-    		// Craft Result
-    		return getSlots(0, 1, false);
-    	}
-    	if(slot.index >= 1 && slot.index < 9) {
-    		// Crafting Grid
-    		return getSlots(1, 9, false);
-    	}
-    	if(action == InventoryAction.MOVE_SIMILAR) {
-    		if(slot.index >= 10 && slot.index <= 45) {
-    			// Full ContainerInventory
-    			return getSlots(10, 36, false);
-    		}
-    	}else {
-    		if(slot.index >= 10 && slot.index <= 36) {
-    			// Main ContainerInventory
-    			return getSlots(10, 27, false);
-    		}
-    		if(slot.index >= 37 && slot.index <= 45) {
-    			// Hotbar
-    			return getSlots(37, 9, false);
-    		}
-    	}
-    	return null;
+    public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
+        if (slot.index == 0) {
+            // Craft Result
+            return getSlots(0, 1, false);
+        }
+        if (slot.index >= 1 && slot.index < 9) {
+            // Crafting Grid
+            return getSlots(1, 9, false);
+        }
+        if (action == InventoryAction.MOVE_SIMILAR) {
+            if (slot.index >= 10 && slot.index <= 45) {
+                // Full ContainerInventory
+                return getSlots(10, 36, false);
+            }
+        } else {
+            if (slot.index >= 10 && slot.index <= 36) {
+                // Main ContainerInventory
+                return getSlots(10, 27, false);
+            }
+            if (slot.index >= 37 && slot.index <= 45) {
+                // Hotbar
+                return getSlots(37, 9, false);
+            }
+        }
+        return null;
     }
-    
+
     @Override
-    public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
-    	if(slot.index >= 10 && slot.index <= 45) {
-    		// Full ContainerInventory
-    		if(target == 1) {
-    			return getSlots(1, 9, false); // To Crafting Grid
-    		}
-    		if(slot.index >= 10 && slot.index <= 36) {
-    			// Main ContainerInventory
-    			return getSlots(37, 9, false); // To Hotbar
-    		}
-    		if(slot.index >= 37 && slot.index <= 45) {
-    			// Hotbar
-    			return getSlots(10, 27, false); // To Main ContainerInventory
-    		}
-    	}else {
-    		// Crafting grid or result
-    		if(slot.index == 0) {
-    			// Crafting Result
-    			return getSlots(10, 36, true);
-    		}else {
-    			// Crafting Grid
-    			return getSlots(10, 36, false);
-    		}
-    	}
-    	
-    	return null;
+    public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
+        if (slot.index >= 10 && slot.index <= 45) {
+            // Full ContainerInventory
+            if (target == 1) {
+                return getSlots(1, 9, false); // To Crafting Grid
+            }
+            if (slot.index >= 10 && slot.index <= 36) {
+                // Main ContainerInventory
+                return getSlots(37, 9, false); // To Hotbar
+            }
+            if (slot.index >= 37 && slot.index <= 45) {
+                // Hotbar
+                return getSlots(10, 27, false); // To Main ContainerInventory
+            }
+        } else {
+            // Crafting grid or result
+            if (slot.index == 0) {
+                // Crafting Result
+                return getSlots(10, 36, true);
+            } else {
+                // Crafting Grid
+                return getSlots(10, 36, false);
+            }
+        }
+
+        return null;
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
index 10f7129ae..ca8ba176d 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFlag.java
@@ -7,6 +7,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotDye;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuFlag extends MenuAbstract {
 	public TileEntityFlag flag;
@@ -38,7 +39,7 @@ public class MenuFlag extends MenuAbstract {
 	 *  30 -  38 Hotbar
 	 */
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 2) {
 			// Dye Slots
 			return getSlots(0, 3, false);
@@ -60,7 +61,7 @@ public class MenuFlag extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 2) {
 			// Dye Slots
 			return getSlots(3, 36, false); // Into ContainerInventory
@@ -69,7 +70,7 @@ public class MenuFlag extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return flag.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return flag.stillValid(player);
 	}
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
index f6890db3a..26ce3aa02 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnace.java
@@ -8,6 +8,7 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotFurnace;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuFurnace extends MenuAbstract {
 	public static final int ID_CURRENT_COOK_TIME = 0;
@@ -86,8 +87,8 @@ public class MenuFurnace extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return furnace.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return furnace.stillValid(player);
 	}
 
 	/**
@@ -99,7 +100,7 @@ public class MenuFurnace extends MenuAbstract {
      */
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 3) return getSlots(slot.index, 1, false);
 
 		if(action == InventoryAction.MOVE_ALL) {
@@ -120,7 +121,7 @@ public class MenuFurnace extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 3 && slot.index <= 39) {
 			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
index e23dc5552..833b062c0 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuFurnaceBlast.java
@@ -2,13 +2,13 @@ package net.minecraft.core.player.inventory.menu;
 
 import it.unimi.dsi.fastutil.ints.IntList;
 import net.minecraft.core.InventoryAction;
-import net.minecraft.core.block.entity.TileEntityFurnace;
 import net.minecraft.core.block.entity.TileEntityFurnaceBlast;
 import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotFurnace;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuFurnaceBlast extends MenuAbstract {
 	public static final int ID_CURRENT_COOK_TIME = 0;
@@ -89,8 +89,8 @@ public class MenuFurnaceBlast extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(final Player entityplayer) {
-		return this.furnace.stillValid(entityplayer);
+	public boolean stillValid(final @NotNull Player player) {
+		return this.furnace.stillValid(player);
 	}
 
 	/**
@@ -103,7 +103,7 @@ public class MenuFurnaceBlast extends MenuAbstract {
      */
 
 	@Override
-	public IntList getMoveSlots(final InventoryAction action, final Slot slot, final int target, final Player player) {
+	public IntList getMoveSlots(final @NotNull InventoryAction action, final @NotNull Slot slot, final int target, final Player player) {
 		if(slot.index >= 0 && slot.index < 4) return getSlots(slot.index, 1, false);
 
 		if(action == InventoryAction.MOVE_ALL) {
@@ -124,7 +124,7 @@ public class MenuFurnaceBlast extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(final InventoryAction action, final Slot slot, final int target, final Player player) {
+	public IntList getTargetSlots(final @NotNull InventoryAction action, final @NotNull Slot slot, final int target, final Player player) {
 		if(slot.index >= 4 && slot.index < 40) {
 			// Full ContainerInventory
 			if(action != InventoryAction.MOVE_ALL) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
index 09a337965..46295eaee 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuGuidebook.java
@@ -5,12 +5,13 @@ import net.minecraft.core.InventoryAction;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuGuidebook extends MenuAbstract
 {
 
 	@Override
-	public boolean stillValid(final Player entityplayer)
+	public boolean stillValid(final @NotNull Player player)
 	{
 		return true;
 	}
@@ -21,12 +22,12 @@ public class MenuGuidebook extends MenuAbstract
 	}
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		return null;
 	}
 	
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		return null;
 	}
 	
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
index c85448158..ef8021653 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuInventory.java
@@ -13,6 +13,7 @@ import net.minecraft.core.player.inventory.container.ContainerResult;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.player.inventory.slot.SlotArmor;
 import net.minecraft.core.player.inventory.slot.SlotResult;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuInventory extends MenuAbstract {
 
@@ -61,7 +62,7 @@ public class MenuInventory extends MenuAbstract {
 	}
 
 	@Override
-	public void onCraftGuiClosed(Player player) {
+	public void onCraftGuiClosed(@NotNull Player player) {
 		super.onCraftGuiClosed(player);
 		boolean insert = false;
 		for (int i = 0; i < 4; i++) {
@@ -78,7 +79,7 @@ public class MenuInventory extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
+	public boolean stillValid(@NotNull Player player) {
 		return true;
 	}
 
@@ -91,7 +92,7 @@ public class MenuInventory extends MenuAbstract {
 	 */
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index == 0) {
 			// Craft Result
 			return getSlots(0, 1, false);
@@ -123,7 +124,7 @@ public class MenuInventory extends MenuAbstract {
 	}
 	
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 9 && slot.index <= 44) {
 			// Full ContainerInventory
 			if(target == 1) {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
index 5f35af980..c4c92412d 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrap.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.entity.TileEntityDispenser;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.Container;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuTrap extends MenuAbstract {
 
@@ -40,12 +41,12 @@ public class MenuTrap extends MenuAbstract {
 	}
 	
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return trap.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return trap.stillValid(player);
 	}
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(dispenserSlotsStart, 9, false);
 		}
@@ -67,7 +68,7 @@ public class MenuTrap extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= dispenserSlotsStart && slot.index < inventorySlotsStart) {
 			return getSlots(inventorySlotsStart, 36, false);
 		}else {
diff --git a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
index cc224e04a..bb4777307 100644
--- a/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
+++ b/game/core/src/main/java/net/minecraft/core/player/inventory/menu/MenuTrommel.java
@@ -8,6 +8,7 @@ import net.minecraft.core.crafting.ContainerListener;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.slot.Slot;
+import org.jetbrains.annotations.NotNull;
 
 public class MenuTrommel extends MenuAbstract {
 
@@ -73,8 +74,8 @@ public class MenuTrommel extends MenuAbstract {
 	}
 
 	@Override
-	public boolean stillValid(Player entityplayer) {
-		return trommel.stillValid(entityplayer);
+	public boolean stillValid(@NotNull Player player) {
+		return trommel.stillValid(player);
 	}
 	
 	/*
@@ -85,7 +86,7 @@ public class MenuTrommel extends MenuAbstract {
 	 */
 
 	@Override
-	public IntList getMoveSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getMoveSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 3) {
 			return getSlots(0, 4, false);
 		}
@@ -112,7 +113,7 @@ public class MenuTrommel extends MenuAbstract {
 	}
 
 	@Override
-	public IntList getTargetSlots(InventoryAction action, Slot slot, int target, Player player) {
+	public IntList getTargetSlots(@NotNull InventoryAction action, @NotNull Slot slot, int target, Player player) {
 		if(slot.index >= 0 && slot.index <= 4) {
 			// Item and Fuel Slots
 			return getSlots(5, 36, false); // Into ContainerInventory
